2024-05-15 2.5.2+ (API 0.9.62) released

2024-05-15 dr|z3d
 * Console:
   - Add realtime js logging filter for router logs on /logs
   - Linkify ip addresses in router logs on /logs

2024-05-14 zzz
 * I2PTunnel: Fix keepalive bug causing truncation of chunked content

2024-05-14 dr|z3d
 * Console: Add refresh interval feature (js) to /logs to permit manually
   configuring the interval, with persistence via local storage

2024-05-12 dr|z3d
 * Console:
   - Add Unknown country to NetDb summary for non-GeoIP resolved peers
   - Ensure pages linked in iframes load at top
   - Migrate inline javascript on /jobqueue to refreshElements.js

2024-05-11 dr|z3d
 * Console: Add Show/Hide Legend button on single graph page

2024-05-08 zzz
 * Router: Publish G cap if symmetric natted
 * Tunnels: Validate peer RI expiration in TunnelPeerSelector

2024-05-09 dr|z3d
 * Console: Update graphs and handle graph manipulation using AJAX

2024-05-06 2.5.1+ (API 0.9.62) released

2024-05-06 dr|z3d
 * Console: Display graphs as SVGs using jfreesvg library
   (I2P integration courtesy of zzz)

2024-04-26 dr|z3d
 * Console: Add delete sybil blocklist button to sybil section
 * Router: Don't tolerate routers sending unsolicited DbSearch reply messages

2024-04-25 zzz
 * Transport: Remove SSU1 code from IMF/IMS (Gitlab MRs !189)

2024-04-24 dr|z3d
 * I2PSnark: Display free space info at startup

2024-04-23 dr|z3d
 * Router: Add bans at SSU2 Establishment phase for various suspect behaviors

2024-04-22 zzz
 * Profiles: Don't update last heard time on tunnel failure
 * Transport: Remove SSU1 code from PeerTest and IntroductionManager
   (Gitlab MRs !185, !186)

2024-04-21 dr|z3d
 * SusiDNS: Enhance presentation of subscription logs and linkify new hosts

2024-04-19 dr|z3d
 * SusiDNS: Reverse the order of the subscription logs so newest
   added domains appear first
 * I2PSnark: Fix display of progress bars on details page

2024-04-17 zzz
 * Build: Update to Tomcat 9.0.88

2024-04-16 dr|z3d
 * Console: Optimize progressx.js and add support for theme-specific colors

2024-04-15 dr|z3d
 * SusiMail: When blocked images are present in HTML view and not shown, add
   a toggle button to enable display of placeholders, with src as tooltip

2024-04-13 zzz
 * Susimail:
   - Reply-all improvements
   - Add sender name to default config, use when replying
   - Improve validateAddress()

2024-04-13 dr|z3d
 * SusiMail: Remove parenthesis and anything contained therein in
   From column in list view

2024-04-13 dr|z3d
 * I2PSnark: Assign active filter query parameter to main nav and close
   search buttons when filterbar is enabled

2024-04-11 dr|z3d
 * I2PSnark: Modify logging output for snark create torrent file filtering
   so we only display path relative to the data dir, not full paths

2024-04-11 snex
 * I2PSnark: Fix create torrent filtering when applying a "." filter and
   log filtered files or filtered file count to screenlogs and terminal

2024-04-08 I2P+ 2.5.0+ released

2024-04-07 dr|z3d
 * SusiMail: Display blocked image count in html messages if
   view.html.blockedImages=false

2024-04-06 dr|z3d
 * SusiMail:
   - Enable dark mode for HTML messages when dark themes active:
     view.html.darkMode={true|false}
   - Hide blocked images in HTML messages by default:
     view.html.blockedImages={true|false}

2024-04-05 zzz
 * SusiMail:
   - Fix truncation of quoted-printable encoded attachments
   - Fix loading mail bodies in non-inbox/drafts folders

2024-04-04 dr|z3d
 * SusiMail:
   - Add icon indicators in list view for HTML attachments
   - Add config option to disable html remote content warning:
     view.html.warning={true|false}

2024-04-03 dr|z3d
 * SusiMail:
   - Merge zzz's html mail viewer code, enhance presentation
   - Fix various potential display issues with html messages,
     swapout broken remote images for a blocked image icon

2024-03-03 dr|z3d
 * I2PSnark: Activate snex's create torrent filtering

2024-03-26 zzz
 * NetDB: Store message handling changes
 * Transports: Incoming connection checks
 * Tunnels:
   - Refactor message distribution
   - Tunnel test changes

2024-03-23 zzz
 * I2PSnark: Preserve private=0 in torrent files

2024-03-01 zzz
 * SSU2: Cancel peer test if Bob picked a Charlie without a B cap

2024-02-29 zzz
 * SSU2: Treat IPv6 peer test result as unknown if no response
   from firewalled Charlie

2024-02-26 zzz
 * I2PSnark:
   - Don't allow changing data dir when connected
   - Delete all torrents except magnets when changing data dir

2024-02-25 zzz
 * SSU2:
   - Increase min version for peer test
   - Update last rcv time when receiving data, not acks

2024-02-10 snex
 * I2PSnark: Implement create torrent file filtering

2024-02-02 zzz
 * I2PTunnel: Implement client-side persistence (Gitlab MR !176)

2024-01-31 zzz
 * CLI: Add sdns stamp decoder

2024-01-30 zzz
 * Naming: Add .i2p.alt support
 * Util: DoH server list update

2024-01-29 dr|z3d
 * Reseeding: Add StormyCloud server

2024-01-29 zzz
 * Crypto:
   - More efficient enum lookup by code
   - Verify RSA sigs after signing
 * I2PSnark: Sanitize unicode LTR/RTL control chars
 * Util: Add .alt to selfsigned cert alt names

2024-01-28 zzz
 * Build: Update gradlew to 8.5 (Gitlab MR !180)

2024-01-27 zzz
 * Console: Update RRD4J to 3.9 (Gitlab MR !178)
 * Transport: Remove SSU1 code from EstablishmentManager (Gitlab MR !179)

2024-01-23 zzz
 * I2PTunnel, susidns: Fix IDN decoding for newer codepoints

2024-01-15 zzz
 * I2CP: Prevent loopback messages to same session
   (i2pd Github #2005, Gitlab MR !173)
 * I2PSnark: Bandwidth limiter improvements (Gitlab MR !164)

2024-01-14 zzz
 * Data: Store compressed RI and LS in compressed form (Gitlab MR !171)
 * I2PTunnel:
   - Add utilities for keepalive (WIP) (Gitlab MR !166)
   - Don't send HTML errors on CONNECT sockets (Gitlab MR !175)
 * Transport: Remove SSU1 code from PacketHandler (Gitlab MR !174)

2024-01-12 dr|z3d
 * Console: Add auto-refresh toggle button to /logs

2024-01-11 dr|z3d
 * Console: Add tunnelId toggler to /tunnels if advanced mode enabled

2024-01-10 zzz
 * SusiMail: Add markdown js for plain text content (Gitlab MR !161)
 * SSU2: Delay sending relay tag (Gitlab MR !169)

2024-01-08 zzz
 * Transport: Ignore SSU1 enable config

2024-01-02 zzz
 * Console: News fetch improvements (Gitlab MR !163)
 * Router: Enforce max RI size (Gitlab MR !168)
 * SusiMail: Speed up initial loading (Gitlab MR !162)
 * Tunnels: Peer selection adjustments (Gitlab MR !167)

2023-12-31 dr|z3d
 * Console: Add support for Noto Sans / Source Sans CJK fonts for graphs

2023-12-30 dr|z3d
 * Router: Fix out-of-bounds error for RDNS domain truncation
 * I2PTunnel: Case-insensitivity when detecting existing http server headers

2023-12-27 dr|z3d
 * Console: Ensure sidebar continues auto-refresh after router restart

2023-12-27 dr|z3d
 * SusiMail: enable image attachment thumbnail previews;
   display file icons for non-images
 * Router: bump minimum version in various places for RI storage,
   selective transit tunnel hosting etc

2023-12-23 zzz
 * SusiMail:
   - Add regex util (WIP)
   - Extract multipart type and content id (WIP)
   - Logging enhancements on file read failures
   - Show size and thumbnail of draft attachments
 * Util: Move SyntheticREDQueue from router to core

2023-12-23 dr|z3d
 * Console: Add redirect for /help/changelog at /changelog

2023-12-22 zzz
 * Blockfile: Fix bug in unused getNames()
 * Console: Fix encoding issues in persisted news
 * I2CP: Add router rates to bandwidth limits message
 * I2PSnark: Adjust max peers for small torrents
 * I2PTunnel:
   - Change return code for host-not-in-addressbook to 502
   - Log correct server host/port on error when multiple targets configured
 * NTCP2: Add key validity check
 * Plugins: Don't auto-update in test mode
 * Ratchet: Use correct method for Elg2 keygen
 * SusiMail: Include attachment sizes in displayed draft size
 * Transports: Don't flood huge RIs
 * Util:
   - Catch OOM in timer
   - Add 2nd order comparison in ObjectCounterUnsafe sort

2023-12-22 dr|z3d
 * Console: Fix sticky sidebar misbehavior at < 1500px viewport width

2023-12-20 dr|z3d
 * I2PSnark: Fix display of bottom page navigation buttons

2023-12-18 I2P+ 2.4.0+ released

2023-12-18 dr|z3d
 * Console: Ensure we write out the news.xml feeds in utf-8 (fix by zzz)
 * Router: stat when we receive a good search reply

2023-12-17 dr|z3d
 * Console: Ensure correct sidebar tunnel status visuals for translations

2023-12-16 dr|z3d
 * I2PTunnel: Process tunnel control events in situ, don't reload page

2023-12-15 dr|z3d
 * Tor blocklist update

2023-12-11 dr|z3d
 * Console: Selectively show shutdown errors in wrapper logs
 * Console: Don't display untagged strings language option on wizard page

2023-12-09 dr|z3d
 * Console: When update is available, display on configupdate

2023-12-08 dr|z3d
 * Installer Fix rare misidentification of OS (patch from zzz)

2023-12-07 dr|z3d
 * SusiMail: Show spam flags for all in spam folder (patch from zzz)
 * Console: Make Check for Updates button more prominent on configupdate

2023-12-06 dr|z3d
 * Console:
   - Refactor configupdate
   - Remove obsolete oldHome pref and conditionals from NewsHelper
   - Add Router Updates link to home

2023-12-04 dr|z3d
 * Console: Form submission improvements in config section

2023-12-02 dr|z3d
 * Console: Iconize help section nav menu

2023-12-02 zzz
 * SusiMail: Fix binary content-encoding

2023-12-01 zzz
 * I2PSnark: Change js mime type as per RFC 9239

2023-11-29 zzz
 * UPnP:
   - Fix missing port in Host header causing failures on libupnp-based devices
   - Fix handing of multiple IGDs
   - Improve logging about multiple IGDs
   - Make case of HTTP headers more standard

2023-11-27 zzz
 * I2PSnark: Delay bandwidth limits check briefly

2023-11-23 dr|z3d
 * Console: Streamline /profiles display

2023-11-21 zzz
 * Addressbook: Workaround for i2p-projekt.i2p etag bug (upstream Gitlab #454)
 * I2PTunnel: Add thread number to server thread names
 * Profiles: Increase congestion cap penalties (upstream Gitlab #412)

2023-11-18 zzz
 * I2PSnark: Uncomment and fix local torrent file picker

2023-11-16 zzz
 * Build: Force build to die on fatal JspC errors

2023-11-15 zzz
 * I2PSnark:
   - Handle metainfo url-list as single byte string
   - Increase comment bucket size to reduce duplicates
   - Sort tracker list on details page

2023-11-12 dr|z3d
 * Router: Don't log ban events if router is already banned
 * Sybil Don't ban NAT64 addresses (patch from zzz)

2023-11-12 zzz
 * Banlist: Throw if banning far in the past, to catch bugs
 * Router: Temp. ban routers publishing in the future
 * Sybil: Don't ban NAT64 addresses

2023-11-11 dr|z3d
 * Router: Fix congestion cap publishing

2023-11-11 zzz
 * Router: Fix congestion cap publishing

2023-11-10 dr|z3d
 * I2PTunnel: Exempt tunnel name from XSS filter (upstream Gitlab #467)
 * NetDb Lookup handler throttler fixes (upstream Gitlab #468)

2023-11-10 zzz
 * I2PTunnel: Exempt tunnel name from XSS filter (upstream Gitlab #467)
 * NetDb: Lookup handler/throttler fixes
   - Allow limited lookups when non-ff, but still disallow expl. lookups
   - Remove unnecessary banlist checks in handler
   - Add lower non-ff limit in throttler
   - Fix check for our RI
   - Remove now-unused stats

2023-11-09 zzz
 * Console: Fix published LS count on the debug LS tab

2023-11-08 zzz
 * NetDb: Fix and deprecate unused store() method

2023-11-04 zzz
 * NetDb: Type changes (Gitlab #402)
   - Revert ctx.netDb() return type change
   - Revert all DummyNetworkDatabaseFacade changes
   - Add DummyNetworkDatabaseSegmentor
   - FNDS/SNDF return type changes
   - Add back casts of netDb() calls to FNDF where necessary
   - Fix console NPE when using DummyNDF

2023-11-02 zzz
 * NetDb: Enforce no RIs in subdbs (Gitlab #465)
   - Throw IAE if attempting to store/publish RI to subdb
   - Log warnings if attempting to lookup RI in subdb
   - Revert changes to createPeerSelector()
   - Revert peer selector changes in SearchJob and StoreJob
   - Use common PeerSelector and KBucketSet for all dbs
   - Revert/fix FloodfillVerifyStoreJob to looukp RIs in the main DB
   - Don't start ExpireRoutersJob in subdbs
   - Revert change in InboundMessageDistributor that was looking up RI in subdb
   - Remove KNDF.isMainDb(), replace with !isClientDb()

2023-10-28 zzz
 * I2PTunnel:
   - Remove nonstandard Proxy-Connection headers (Gitlab #452)
   - Fix gzip footer check in GunzipOutputStream (Gitlab #458)
 * NetDb: Fix lifecycle issues for subsessions (Gitlab #460, #406)
   - Don't create subdb for subsession and lose ref for primary subsession;
   - Simplify CCR.getFNDF() to simply return the subdb or null; nothing else is necessary
   - Do not unpublish LS from main db on session shutdown; not necessary, it is not in there

2023-10-24 zzz
 * NetDb: Subdb lifecycle fixes (Gitlab #406)
   - Disable RefreshRoutersJob for subdbs
   - Cancel ExpireRoutersJob and ExpireLeasesJob at netdb shutdown
   - Do not run ExpireRoutersJob at shutdown for subdbs
   - Do not create _exploreKeys HashMap for subdbs, and add checks for subdbs
   - Convert NegativeLookupCache timer to SimpleTimer2 so we may cancel it
   - Add method to cancel NegativeLookupCache timer; cancel it when netdb shuts down

2023-10-22 dr|z3d
 * Core: Update clearnet user agent string as per latest Tor browser
 * I2PSnark: Show correct count on filter badge when search is active
 * Router: Reimplement no GeoIP router bans 10m grace period after startup

2023-10-21 zzz
 * Tests:
   - Disable console scala tests in gradle tests
   - Exclude BuildMessageTestStandalone from gradle tests
 * SAM: Reset incoming socket if no subsession is matched (Gitlab #456)

2023-10-17 dr|z3d
 * Console:
   - Remove some cruft from home and searchbar
   - Allow vertical resize for configlogging textarea

2023-10-12 dr|z3d
 * I2PTunnel:
   - Add some default mimetypes in case we don't find any in the response headers
   - Add some header null checks, source cleanups
   - Add cache control, referrer policy, x-xss-protection headers if missing in HTTPServer

2023-10-12 zzz
 * I2PTunnel: HTTPResponseOutputStream cleanups

2023-10-11 dr|z3d
 * Reseeding: Add prestium reseed hosts and certs
 * I2PTunnel:
   - Increase max packet size in I2PTunnelRunner
   - Increase cache size for http response

2023-10-10 zzz
 * I2PSnark: Shutdown incomplete torrents first

2023-10-03 zzz
 * SSU2: Prevent rare IAE in peer test timer (Gitlab #433)

2023-10-10 dr|z3d
 * Router: Fix in-console rendering of flags
 * Console: Improve rendering time of tunnels pages

2023-10-09 dr|z3d
 * Console: Unsigned update notification improvements courtesy of zzz

2023-10-07 dr|z3d
 * Console: /home and /graphs pages rendering speedup

2023-10-02 dr|z3d
 * I2PSnark:
   - Speed up rendering of main torrents table
   - Preload fonts
 * Console
   - Speed up rendering of /tunnelpeercount and js fixes

2023-09-30 dr|z3d
 * SSU2: Prevent rare IAE in peer test timer Gitlab 433
 * I2PSnark: eventlistener improvements in refreshTorrents.js
 * Console: I2PTunnel unique names for xhr requests
 * Console/Webapps: Don't use capturing phase in js unless needed

2023-09-29 zzz
 * SAM: Fix accept after soft restart (Gitlab #399)

2023-09-27 dr|z3d
 * Console: Check for presence of countries table before adding sort listeners
 * Console: Ensure sidebar section toggler works when refresh disabled

2023-09-27 zzz
 * Debian: Change JRE dependency order (Gitlab #443, Debian #1024461)
 * I2PSnark: Prevent start-all from within search results erroring (Gitlab #445)
 * NTCP2: Fix updating address on transition to firewalled (Gitlab #435)
 * SSU2: Fix uncaught IAE caused by itags with zero values (Gitlab #415)
 * Transport: Fix NPE during soft restart (Gitlab #437)

2023-09-26 dr|z3d
 * Imagegen: Speed up generation of identicons

2023-09-25 dr|z3d
 * Console/Webapps/eepsite: Remove svg xlink namespace, convert xlinks to hrefs

2023-09-22 dr|z3d
 * SusiDNS: Remove mimetype sniffing from headers.jsi since we're just using the URI
 * Console: Suppress logging the file extraction process for reseed zips

2023-09-20 dr|z3d
 * Console: Reduce max threads from 24 to 8
 * Console: Indicate updated table cells when refreshing on /jobs

2023-09-19 dr|z3d
 * Eepsite: Don't serve cookies (max-age: 0)

2023-09-18 dr|z3d
 * I2PSnark: Reduce max messages in screenlog to 50 was 100

2023-09-15 dr|z3d
 * I2PSnark: Remove redundant IE8 9 workarounds and checks in lightbox.js

2023-09-14 dr|z3d
 * Console: Display wrapper logs newest entry at top to match router logs and
   presentational improvements

2023-08-29 dr|z3d
 * Console: Don't display Tunnel lag indicator in sidebar if 0

2023-08-27 dr|z3d
 * Router: Add reverse DNS lookup file cache when RDNS is enabled

2023-08-20 dr|z3d
 * Console: Update url for /I2PTunnelmgr to /tunnelmanager
 * Console: Rename some pages with auto redirects from old page names

2023-08-19 dr|z3d
 * Console: Sticky sidebar improvements

2023-08-09 dr|z3d
 * I2PSnark: Add new magnets column to main view toggled via javascript

2023-08-01 dr|z3d
 * Router: Don't build client tunnels with congestion cap peers

2023-07-12 dr|z3d
 * Jetty update default eepsite caching policies

2023-07-11 dr|z3d
 * Console: swapout home news bg image dark

2023-06-30 I2P+ 2.3.0+ released

2023-06-30 dr|z3d
 * Console: Fix display of floodfills in /profiles section

2023-06-28 dr|z3d
 * Router: Add info level logging for replies as floodfill to lookup requests

2023-06-28 idk
 * Router:
   - Cache stores of multihomed leaseSets when stored from multihome peers,
     and if our local LS is not in the keyspace return multihome instead
   - When updating a leaseSet because recieving it as published always
     make a complete copy of the leaseSet before merging the flags.
   - Rate limit peer lookup requests

2023-06-21 dr|z3d
 * I2PTunnel: Add server/client status counters to index page

2023-06-15 dr|z3d
 * Console: Add UI toggle to enable/disable alternative display font for console
   and default web apps

2023-06-14 dr|z3d
 * Console: enable auto-refresh for /netdb and /stats

2023-06-12 dr|z3d
 * Console: Switch from post to get for netdb lookups

2023-06-07 dr|z3d
 * Console: Merge upstream cosmetic fixes for graph rendering

2023-05-29 idk
 * Router: Add "virtual contexts" to bloom filter, where each entity that passes
   an i2np message to the bloom filter xor's the messageID with a random, local value.
   credit Xe Iaso for discovering the issue, obscuratus for the solution

2023-05-14 dr|z3d
 * Console: Iconize navbar links in configuration section

2023-05-10 dr|z3d
 * Console: Add visibility toggle for settings panel on /graphs

2023-05-05 dr|z3d
 * Router: Reject unsolicted RIs if unreachable or no GeoIP data

2023-05-01 dr|z3d
 * Router: Increase DNS cache time to 1h (was 2m)
 * Console: Incorporate congestion caps indicators into sybil section

2023-04-18 dr|z3d
 * Router: Force immediate disconnect from peers publishing wrong IP address

2023-04-14 dr|z3d
 * Console: Disable router updates via torrent unless
   routerconsole.enableTorrentUpdates=true

2023-04-11 dr|z3d
 * Installer: Delete Windows-specific files post-install on non-Windows,
   esp. wrapper-windows.jar which was preventing wrapper from functioning

2023-04-09 dr|z3d
 * Console: Remove option for redundant Peers (advanced) sidebar section

2023-04-08 dr|z3d
 * Console: Add auto-refreshing session bans page to /profiles

2023-03-28 dr|z3d
 * Router: Increase ban time for routers making excessive lookup requests
 * Console: Show peer test avg in sidebar by default; show message delay
   on congestion badge

2023-03-26 dr|z3d
* Proxy: Update outproxy UserAgent to latest Tor browser version

2023-03-26 dr|z3d
 * I2PTunnel: Allocate more handler threads for I2PTunnelserver according to
   JVM-allocated RAM

2023-03-26 dr|z3d
 * Console: Add Congestion caps count on /netdb

2023-03-22 dr|z3d
 * Blocklist:
   - Add router.blocklistCountries.enable option to enable selective
     blocking of countries
   - Add router.blocklistFeed.enable option to enable/disable feed blocklist
 * Console: Add known peers to sidebar peers badge

2023-03-21 dr|z3d
 * i2ping: Allocate more ram to the JVM to avoid OOM on newer java versions
   (reported by dragonheart)

2023-03-20 dr|z3d
 * Router: Logging tweaks - don't display job id for warn level entries

2023-03-19 dr|z3d
 * Console: Display ip address if no authoritative hostname on /profiles

2023-03-18 dr|z3d
 * Router: Log caps and version of older/unreachable routers when ignoring
   tunnel requests

2023-03-17 dr|z3d
 * I2PTunnel: Add address helper link for qualifying servers on index page

2023-03-15 dr|z3d
 * Installer:
   - Supply wrapper-windows.jar with universal installer for Win64
   - Update service wrapper to 3.5.51 for non-Windows; drop ARM6

2023-03-15 dr|z3d
 * Wrapper: Upgrade to 3.5.51

2023-03-14 I2P+ 2.2.0+

2023-03-13 idk
 * Send and check target destination in first streaming SYN packet

2023-03-13 dr|z3d
 * Router:
   - Don't flood unsolicited RIs we always reject
   - Don't accept unsolicited RIs for banned routers

2023-03-12 dr|z3d
 * Router: Never accept unsolicited store of RIs for various categories of
   router (old and unreachable, floodfill with SSU disabled etc)

2023-03-11 dr|z3d
 * Router:
   - Don't activate connection throttler until connections 2/3 of limit
   - Immediately disconnect from banned floodfills

2023-03-08 dr|z3d
 * Console: Add indicators to router b/w widgets for congestion caps

2023-03-07 dr|z3d
 * Console/Webapps: Replace monospaced font Droid Sans Mono with Fira Code
 * Router:
   - Perform reverse lookup when writing RIs to disk if reverse lookups enabled

2023-03-06 dr|z3d
 * Console: Shorten sidebar restart notification msg if advancedmode

2023-02-23 dr|z3d
 * Router: Ignore tunnel requests from older, unreachable routers

2023-02-22 dr|z3d
 * Console: Add tunnel accept/reject count to /profiles
 * Router: Add blocklist for Tor exit nodes

2023-02-21 dr|z3d
 * Installer: Upgrade launch4j from 3.0.1 to 3.5.0

2023-02-19 dr|z3d
 * Console: Add b/w tier counter to /peers table headings

2023-02-18 dr|z3d
 * Console: Ensure sort order on ntcp/ssu connection pages is sticky

2023-02-16 dr|z3d
 * Console: Show simplified SSU table & advanced view tab when in adv mode

2023-02-16 zzz
 * Transports: Add new inbound connection throttler

2023-02-15 dr|z3d
 * Console: Make columns sortable for NTCP/SSU peers tables

2023-02-15 zzz
 * Router:
   - Disable Sybil analysis when in test mode
   - Store feed blocklist in main array for efficiency
 * Tunnels: Re-enable using U routers in some expl. tunnels

2023-02-13 zzz
 * Profiles:
   - Change the new-router bonus to a penalty
   - Remove unused failing peers map

2023-02-12 dr|z3d
 * Console: Add link to tunnel build success graph from sidebar label

2023-02-12 zzz
 * Console: Reduce max age of displayed profiles
 * NetDb:
   - Don't create profile unless peer is reachable
   - Store handler updates
 * Profiles:
   - Adjust capacity for send success/failure
   - Don't create new profile on message or lookup failures
   - Downrate capacity of slow/unreachable peers
   - Limit storage and memory usage
 * Router: Increase min version for tunnels and netdb to 0.9.51
 * Tunnels: Don't build through U routers

2023-02-11 dr|z3d
 * Router: Prevent incoming connections from banlisted peers

2023-02-11 zzz
 * NetDb:
   - Expiration tweaks
   - Increase flood thottle time

2023-02-10 zzz
 * Router: Tighten skew calculation window

2023-02-09 dr|z3d
 * Router: Add N tier to caps we demote from fast/high cap tiers

2023-02-09 zzz
 * DTG: Support notification disable/enable in non-router context
 * NetDb:
   - Don't lookup before dropping after shutdown initiated
   - Improve efficiency of ExpireRoutersJob
 * Profiles: Don't delete old profiles from disk until 90m uptime

2023-02-08 zzz
 * Console:
   - Add routing key to router infos (advanced)
   - Debug page sockets table cleanup
   - Load router infos more efficiently
 * NetDb:
   - Don't explore if we have enough RIs
   - Further restrict what RIs we lookup before dropping
   - Implement faster RI expiration mode
   - Increase closest-floodfill search size
   - Reduce min RI expiration
   - Reduce max floodfill fail rate
   - Replace Set with List in ExpireLeasesJob for efficiency
   - Set max routers to load at startup
 * NTCP2:
   - Ban peers that ban us
   - Block IP on failed inbound
   - Increase temp. inbound IP block time
   - Route RI block of another router to InNetMessagePool
 * Router:
   - Don't set congestion cap at startup because of high job lag
 * Sybil:
   - Don't do pair distance check unless enough memory
   - Thread analyzer at reduced priority
 * Transports: Check RI in handshake for matching IP
 * Tunnels: Load RIs more efficiently in peer selector

2023-02-07 dr|z3d
 * Router: Retain profiles for longer if interesting

2023-02-06 dr|z3d
 * Console:
   - Add indicators for unreachable/floodfill peers on RI widgets
   - Add fastest transit tunnel page; limit to max 200 peers

2023-02-05 dr|z3d
 * Console:
   - Don't show single shot or disabled jobs on jobqueue stats
   - Overhaul flag + hash router representation
    - Display b/w tier in separate column on peers pages

2023-02-04 zzz
 * Router:
   - Continue work on congestion caps (proposal 162)
   - Stat cleanup

2023-02-03 zzz
 * I2PSnark: Fix failure on torrents with '#' in the name
 * Util: Fix check for illegal chars in storeProps()

2023-02-02 dr|z3d
 * Console:
   - Optional reverse dns lookups for peers on transit & tunnels
     by count pages (enable with routerconsole.enableReverseLookups=true)

2023-02-01 dr|z3d
 * Console: Cancel sidebar refresh timer when browser tab not active

2023-02-01 zzz
 * Console: Don't list same client SKM twice on /debug for subsessions
 * Profiles:
   - Count all build rejections in tunnel history
   - Remove 30m tunnel history rates
 * Ratchet: Don't bundle LS with ratchet ACK

2023-01-31 dr|z3d
 * Console: Limit display to max 50 peers on transit summary page
 * Router:
   - Add peer flag renderer to CommSystemFacade
   - Increase PumperTunnelGateway buffers and make ~ symmetrical
   - Halve PTG queues if under sustained CPU load

2023-01-30 zzz
 * Tunnels: Refactor peer selection
 * Blocklist:
   - Don't maintain IPv6 blocklist unless we have an IPv6 address
   - Don't read in same-country blocklist unless configured or in strict country
 * NTCP2: Ensure we publish a "6" address on transition to firewalled
 * Streaming: Refactor sig checking
 * Tunnels:
   - Refactor peer selection
   - Improve expl. build success in well-connected routers during congestion
 * Util: Add experimental config to bypass Fortuna and just use /dev/random

2023-01-29 dr|z3d
 * Console:
   - Increase threads and allocation memory for graph rendering
   - Add additional default graphs

2023-01-27 dr|z3d
 * Router: Throttle tunnel builds if CPU load average  > 95
 * Console: Sidebar refresh optimizations

2023-01-27 zzz
 * Console: Debug page cleanups
 * Tools: Add CLI reseed test
 * Tunnels: Reduce grace period from 120 to 90 sec.

2023-01-26 dr|z3d
 * Router: Upgrade out of date router log event to critical
 * Console: Don't show peer count if 0 in NetDb b/w tier section

2023-01-26 zzz
 * Console: Add revision and build date to version info
 * I2PSnark: Search fixes

2023-01-25 zzz
 * Util: New thread-unsafe version of ObjectCounter

2023-01-24 zzz
 * Router: Preliminary support for congestion caps (proposal 162)

2023-01-23 dr|z3d
 * Console: Prevent auto-update to vanilla I2P

2023-01-23 zzz
 * I2PSnark standalone: Fix running from outside the directory

2023-01-22 zzz
 * Build: Fix list of changed files in manifests
 * I2PSnark: Add max files per torrent config

2023-01-21 zzz
 * Console:
   - Remove ERR- and WARN- prefixes from status strings
   - Catch graph error in Docker (Gitlab #383)
 * I2PSnark: Search box CSS
 * NTCP: Do not rebind internal port if only SSU external port changed
 * SSU:
   - Eliminate Symmetric NAT errors for "full cone" NATs
   - Fix rare peer test NPE
   - Fix initial SSU2 MTU when SSU1 disabled

2023-01-20 dr|z3d
 * Console:
   - Add tunnel build success indicator to sidebar tunnel section
   - Add optional build success graph

2023-01-19 dr|z3d
 * Router: Disable SSU1 by default

2023-01-19 zzz
 * Build: Add I2PSnark-release target

2023-01-18 dr|z3d
 * I2PSnark: Add required attribute to search input
 * Core: Add getCPULoadAvg() to SystemVersion

2023-01-18 zzz
 * I2PSnark: Search CSS and JS

2023-01-17 dr|z3d
 * Console:
   - Split peer b/w tier into own column on /tunnelpeercount
   - Ensure sidebar max part tunnels displays the correct value
 * Router:
   - Slow down refresh routers job if under high cpu load
   - Delay Explorer Job if under high cpu load
 * I2PSnark: Apply filters to all loaded torrents if multi-page

2023-01-17 zzz
 * I2PSnark:
   - Add basic search box
   - Recognize more clients
 * I2PTunnel: Fix typo for SSL outproxy host

2023-01-16 dr|z3d
 * Router:
   - Slow down peer test job if we're under load
   - Increase minimum fast tier routers to 200 (was 150)
 * Console:
   - Add stackoverflow search (via ddg) to /home
   - Don't load sidebar assets when refreshing via XHR

2023-01-15 dr|z3d
 * I2PSnark: Add pagesize query param (patch by zzz)

2023-01-15 zzz
 * Console:
   - Fix displayed BPS for SSU peers
   - Add netdb search by introducer count
 * I2PTunnel:
   - Interrupt client tunnel build when stop button is clicked
   - Return error message from IRC client on failure to build tunnels
   - Return 503 from HTTP client on failure to build tunnels
   - Return error code from SOCKS client on failure to build tunnels

2023-01-14 dr|z3d
 * I2PSnark:
   - Simplify ajax refresh
   - Don't refresh when browser tab not visible
 * Core:
   - Add getSystemLoad() and getCPULoad() to SystemVersion
 * Router:
   - Increase EventPumper interval and Iterative Search concurrency
     if under high load
 * Console:
   - Add optional JVM CPU bar to /configsidebar
   - Add system load average to CPU bar tooltip

2023-01-13 dr|z3d
 * Console: Add additional site searches to /home

2023-01-12 zzz
 * Router: Simplify published stats values
 * SAM: Abort tunnel build if control socket closes

2023-01-11 zzz
 * Console: Add ability to search netdb for a range of ports

2023-01-11 zzz
 * Console: Add ability to search netdb for a range of ports

2023-01-10 I2P+ 2.1.0+ released

2023-01-08 zzz
 * AppArmor: Allow classes.jsa in other locations
 * SSU:
   - Fix NPE handling SSU1 peer test msg 7
   - Build fix for Java 7

2023-01-07 dr|z3d
 * Router: Increase max outbound bandwidth share if >=8 cores && >=4096MB

2023-01-06 dr|z3d
 * Router: Enhance participating throttler logging

2023-01-05 dr|z3d
 * Console: Add b33 definition to glossary

2023-01-04 dr|z3d
* Router:
  - Reduce tunnel growth factor for transit tunnels (was 1.3, now 1.2)
  - Increase timeout/first hop timeout for tunnel local requests

2023-01-03 dr|z3d
 * Router:
   - Exclude M tier routers from local tunnel builds by default and
     don't store RIs on disk
   - Standardize temp ban for hostile / excessive tunnel requests to 30m

2023-01-03 dr|z3d
 * Router: Add temp banning to RequestThrottler

2023-01-01 zzz
 * GeoIP 2023-01-01
 * I2PTunnel: Do not retry if session limit exceeded

2022-12-31 dr|z3d
 * Console: Add licensing exception for I2P to help/legal

2022-12-31 zzz
 * I2PSnark:
   - Update tracker list after editing torrent (Gitlab #380)
   - Throttle torrent startup to prevent OOMs

2022-12-30 zzz
 * UPnP: Catch AssertionError when closing SSDP multicast socket
 * Util: Add methods to convert IPv6 addresses to canonical RFC 5952 strings

2022-12-29 zzz
 * Tunnels: Limit requested client tunnels during congestion

2022-12-28 dr|z3d
 * Router: Adjust min tunnels before throttle, default max part tunnels

2022-12-26 zzz
 * Console: Sort tunnels by name on /tunnels, /configtunnels, /I2PTunnel
 * Router: Don't blocklist our own IP
 * SSU:
   - Fix NPE when SSU2 disabled
   - Redesign peer test symmetric NAT detection

2022-12-23 zzz
 * SSU2:
   - More peer test fixes
   - Refactor in-session PacketBuilder2 methods to throw IOE

2022-12-22 dr|z3d
 * Router: Vary NTCP event pumper thread sleep according to system specs

2022-12-22 zzz
 * SSU:
   - Further restrict states to publish peer test cap
   - Peer test scheduling fixes
 * SSU2:
   - Further restrict states to be a peer test Charlie
   - Peer test fixes

2022-12-21 dr|z3d
 * Tunnels: Harden participating throttler to mitigate against observed abuse
 * I2Tunnel: Standardize error pages sent by http server tunnel
 * Console: Add sub-titles to various tabbed pages (NetDb, Profiles, etc)

2022-12-21 zzz
 * CLI: Add a "help" command, improve command listing
 * Router: Add IPv6 analysis to Sybil checker

2022-12-20 zzz
 * Router: Add IPv6 localhost and wildcard to blocklist
 * SSU2: Peer test improvements and fixes
 * Util: Speed up IP string to byte conversion

2022-12-19 dr|z3d
 * Router: Don't bother with lookups for uninteresting peers

2022-12-19 zzz
 * CLI: Add NewsHandler CLI to fetch news from servers
 * Console: Fix IPv6 searches for compressed/expanded address format
 * Router: Time initialization fixes and cleanups
   - Require two peers that agree for transports to initialize time
   - Allow SSU2 to initialize time even for large skews
   - Do not allow NTCP2 inbound to initialize time for large skews
   - Adjust SSU2 skew for RTT
   - Disable SSU1 time initialization when SSU2 is enabled
   - Round time sent in NTCP2 DateTime block

2022-12-18 zzz
 * SSU2: Compress and bundle Alice RI with relay intro

2022-12-17 dr|z3d
 * I2PSnark: Various javascript improvements/optimizations

2022-12-17 zzz
 * Console: Fix UDP disabled error when SSU 1 disabled
 * SSU:
   - Don't call rebuildIfNecessary() from dropPeer() and addPeer() every time
   - Don't call test forceRunSoon() in addPeer() every time
   - Fix IP closeness check when firewalled
 * SSU2:
   - Immediately remove establish state from EstablishmentManager on fatal error
   - Send in-session termination after certain session confirmed errors
 * Transport: Fix multiple v4/v6 RouterAddresses

2022-12-16 dr|z3d
 * Console: Persist error level logs in addition to critical logs

2022-12-15 zzz
 * Router: Change transient IPv4 blocklist to LHMCache
 * SSU2:
   - Check banlist after session confirmed
   - Don't attempt to connect to ourselves as an introducer
   - Fix retransmission of session confirmed

2022-12-14 dr|z3d
 * Console: Finish implementation of collapsible sidebar sections
 * Router: Adjust minimum/maximum share bandwidth limits

2022-12-14 zzz
 * Crypto: Fix wrong arguments order in ChaCha20 encrypt, breaking encrypted LS2
 * NTCP:
   - Fix rare NPE sending termination
   - Log source of clock adjustment at startup
 * SSU2:
   - Catch "shift too big" IAE from acked bitfield while sending termination
   - Drop short session request messages in packet handler
   - Preliminary fixes for handling retransmitted retries
   - Reject peer test or relay as Charlie if snatted
   - Update activity on path challenge/response

2022-12-13 zzz
 * SSU: Don't publish B cap when snatted
 * Tunnels: Tighten the hop throttle more

2022-12-12 zzz
 * SSU2: Bob asks another Peer Test Charlie on rejection

2022-12-11 dr|z3d
 * Imagegen: Display identicon/QR form submissions in situ;
   add 1024x1024 scaled examples

2022-12-11 zzz
 * SSU2:
   - Ban peer if he bans us in retry
   - Destroy PS2 cipher states when done
   - Handle retransmitted token request
   - Handle skew reason in termination, possibly ban peer
   - Send termination on inbound session/token request
   - Wait longer for session request after retry

2022-12-10 zzz
 * Graphs: Fix RRD time skew handling
 * SSU: Update activity timestamps for relay and peer test messages
 * SSU2: Peer Test fixes

2022-12-09 dr|z3d
 * Console: Add link to eventlog on router logs header if in advanced mode

2022-12-09 zzz
 * SSU: Don't bid on SSU1 addresses when disabled
 * Tunnels: Tighten the hop throttle

2022-12-08 zzz
 * SSU2: Fix rare IAE creating ACK block

2022-12-07 zzz
 * Console: Profile tabs cleanup
 * SSU2: Post-termination handler improvements

2022-12-06 zzz
 * SSU2: Add handler to process post-termination messages

2022-12-04 zzz
 * SSU2: Token improvements and fixes

2022-12-02 zzz
 * Debian: Fix for stray symlinks in / (gitlab #376)

2022-11-30 zzz
 * SSU: Start work on option to disable SSU 1

2022-11-28 dr|z3d
 * Console: Updates to NetDb lookup page (dropdowns from upstream etc)
 * I2PSnark: Persist screenlog toggle state

2022-11-28 zzz
 * I2PTunnel: Update encryption type defaults
 * Util: Add path length constraint = 0 to selfsigned certs

2022-11-26 dr|z3d
 * Router: Don't publish extended stats to netdb unless enabled via config

2022-11-26 zzz
 * Console: Hide IPv4/v6 columns on /peers status tab
 * I2PTunnel: Fix SOCKS outproxy port configuration
 * SSU: Don't build a 4 cap address at startup if configured for IPv6-only
 * SSU2: Avoid rare NPE handling apparent session confirmed without inbound state
 * Util: Fast check for random nextInt(1) and nextLong(1)

2022-11-25 zzz
 * I2PTunnel: Allow IRCv3 ACCOUNT and CHGHOST through the filter
 * Profiles: Don't let one corrupt file kill the loader thread

2022-11-24 dr|z3d
 * Console: Add auto-refresh toggle to peers SSU/NTCP table headers

2022-11-24 zzz
 * Console, I2PSnark standalone: Fix UI configuration for Argentinan Spanish
 * I2PSnark: Add partial Danish translation
 * I2PSnark standalone: Enable zh_TW UI configuration

2022-11-23 zzz
 * Build: Add debcheckpatch to release targets
 * CLI: Sort MTU output by address
 * Console:
   - Add status and banned tabs to /peers (WIP)
   - Cleanup /debug update and app manager sections
 * Crypto: Don't use AccessController in I2PProvider, deprecated as of Java 17
 * I2PTunnel:
   - SOCKS5 tunnel improvements and torsocks support
   - Fix log message on config migration
 * Router: KeysAndCert compressible padding (Proposal 161, Gitlab MR !66)
 * SSU2: Increase Session Created max padding

2022-11-21 I2P+ 2.0.0+ released

2022-11-19 dr|z3d
 * Router:
   - Reduce iterative search concurrency if known routers > 4000
     and reduce threshold for skipping searches
   - Reduce processing time threshold before throttling part tunnels

2022-11-16 dr|z3d
 * I2PTunnel: Remove xml doctype and transitional html tags from jsp files
 * Router: Start expire participating tunnels job sooner after startup

2022-11-15 dr|z3d
 * I2PTunnel: Add variance to tunnel status tooltip; display as css tooltip
 * Build.xml: Add support for pack200 updates for all Java versions

2022-11-12 zzz
 * I2PTunnel: Fix IRC USER filtering

2022-11-11 dr|z3d
 * Console: Add redirect pages for /help and /console

2022-11-09 zzz
 * SAM: Add warning at startup if not bound to localhost

2022-11-05 NarratorZ
 * Console/Webapps: Chinese translation updates

2022-11-04 dr|z3d
 * Console: Tag help pages and other console strings for translation

2022-11-01 zzz
 * GeoIP 2022-11-01
 * SSU:
   - Fail SSU2 on all session request after retry errors
   - Prefer in China

2022-10-19 zzz
 * Console: Register NavHelper with ClientAppManager as NavService
 * Debian: Change dependency from transitional package libservlet3.1-java
   to libjsp-api-java and libservlet-api-java
 * I2PSnark: Register additional instances with NavService
 * SusiMail: Add icons to the buttons that were missing them (dark theme)

2022-10-17 zzz
 * Console: CSS fixes for lists in news entries
 * Tunnels: ConnectChecker fixes

2022-10-16 zzz
 * SSU2: Use from port in hole punch if different from relay response port

2022-10-15 zzz
 * I2PSnark: Increase piece limit to 64K

2022-10-11 dr|z3d
 * Console: Alternative display fonts and global override.css file for use
   with all themes/webapps (console/dark/override_Sora.css)

2022-10-10 term99
 * graceful_restart.sh updates

2022-10-10 zzz
 * SSU2: Track recently-closed sessions (gitlab #370)

2022-10-01 dr|z3d
 * I2PTunnel: Generic 403, 408, 429 http errors; Add 15s meta refresh
   for 408 (request timeout)

2022-09-28 zzz
 * Installer: Fix error on Windows when username contains a space (gitlab #367)
 * SSU2: Enable by default

2022-09-23 zzz
 * SSU2:
   - Fail handshakes while inside sync
   - Convert 1276 MTU to 1280 to workaround bug in 1.9.0
   - Ensure min packet size for pings

2022-09-20 zzz
 * I2PTunnel, eepget: Add support for SHA-256 digest proxy auth (RFC 7616)

2022-09-16 dr|z3d
 * Proxy: Translation updates (de/fr/ru/uk/zh)

2022-09-10 dr|z3d
 * I2PSnark: Cleanup refreshTorrents.js
 * Router:
   - Increase max IB/OB messages per pump for non-slow routers
   - Increase priorityblockingqueue & backlog queue if >=4GB JVM

2022-09-09 zzz
 * SSU2: Enable handling of ack-immediate flag by default

2022-09-07 zzz
 * SSU: Fallback processing for MTU detection
 * Transports: Don't rekey noise params on testnet

2022-09-06 zzz
 * NetDb: Fix reseeding when clock is skewed
 * SSU2: Don't publish or connect if our MTU becomes too small

2022-09-04 zzz
 * SusiDNS: Fix adding to empty address book

2022-09-03 zzz
 * NetDb: Query connected peers for their RI directly
 * UPnP: Fix opening IPv6 ports

2022-09-01 zzz
 * Router: Ensure database store message is processed before reply job (Gitlab #364)

2022-08-30 dr|z3d
 * Wrapper: Reduce restart delay and jvm timeout (new installs)
 * I2PSnark: Persist torrent filters via localStorage

2022-08-29 zzz
 * SSU2: Implement ack-immediate flag

2022-08-28 zzz
 * Console:
   - Add notification and summary bar info on deadlock
   - Linkify router hash even if not in netdb
 * Util: Add option to gzip router logs

2022-08-25 zzz
 * Router: Fix deadlock via rebuildRouterAddress() and UDPTransport
 * SSU2:
   - Implement path challenge and connection migration
   - Fix packets exceeding MTU by up to 3 bytes
   - Immediately fail session request containing zero token

2022-08-24 1.9.0+ released

2022-08-24 dr|z3d
 * Console: Reduce deadlock detector interval to 1hr (was 24)
 * Router:
   - Increase max in/outbound message per pump for non-slow routers
   - Increase priority blocking queue/backlog for non-slow routers

2022-08-23 dr|z3d
 * Router:
   - Relax throttle for message sent to unconnected peers
   - Automatically enable SSU2 for routers with < 4 cores
 * I2PSnark: Persist torrent filters via local storage (patch by HaruCode)
 * graceful_update: Fixes and improvements from term99
 * I2PTunnel: Relax default throttles for server tunnels

2022-08-23 zzz
 * Router: Add deadlocks to event log

2022-08-22 dr|z3d
 * Router:
   - Increase probability of SSU2 activation to 1 in 4
   - Mitigate lookup failure for new leasesets (patch by Obscuratus)

2022-08-10 zzz
 * SSU2: Enable for Android, ARM, and 2% of others

2022-08-07 dr|z3d
 * Router: Sync UDPSender CoDel parameters with global settings and enable
   global config override

2022-08-06 dr|z3d
 * Router: Reduce peer test frequency for SSU IP detection to 5m (was 13)
 * Console: Add info about i2np.udp.disablePeerTest to advanced help

2022-08-06 zzz
 * GeoIP 2022-08
 * Router: Hopefully fix clock/job queue deadlock after clock shift

2022-08-05 zzz
 * SSU: Try to keep a mix of v1/v2 introducers

2022-08-04 dr|z3d
 * Console: Use snark icon in sidebar service tunnels section

2022-08-04 zzz
 * I2PTunnel: New outproxy (new installs only)
 * SSU2: Block bob's IP in relay response from charlie

2022-08-02 zzz
 * SSU2: More Path challenge WIP

2022-07-31 zzz
 * SSU2: Add state lookup by conn ID

2022-07-29 zzz
 * LogManager: Prevent hangs at shutdown on Mac after dock right-click-quit (Gitlab #363)

2022-07-27 zzz
 * NetDb: Publish ff stats based on current caps, not previous
 * Router: Log warning if no family keys loaded
 * SSU: Decrease MTU only on retransmit of large packets
 * SSU2: Stub out path challenge

2022-07-26 zzz
 * SSU2: Send termination in response to termination

2022-07-25 zzz
 * SSU2: Fix bitfield shifts of 256 or more

2022-07-25 dr|z3d
 * Router: Reduce default peer test timeout to 800ms (was 1s)

2022-07-24 dr|z3d
 * Console:
   - Ensure meta refresh tag is removed from <head> when console
     becomes visible
   - Link to /profiles from Peer Test Average label in sidebar

2022-07-23 dr|z3d
 * Console: Use sliders on /confignet
 * I2PTunnel: Add option for +/-3 tunnel hop variance for server tunnels
   in advanced mode

2022-07-21 dr|z3d
 * ClientManager: Increase default max sessions to 512

2022-07-21 zzz
 * Console: Fix saving flat clients.config file

2022-07-19 dr|z3d
 * Router: Increase max floodfills to push new leaseset to

2022-07-19 zzz
 * GeoIP: Don't lookup route48 addresses
 * SSU:
   - Reduce max establishment time
   - Retransmit handshake messages faster and expire faster (SSU 1/2)
 * SSU2:
    - Shorten token expiration based on cache size
    - Retransmit session confirmed after receiving apparent retransmitted session created
    - Fix storage/checking of local firewalled IP address/port in token file

2022-07-17 zzz
 * SSU2:
   - More MTU fixes
   - Verify static key in RI
   - Don't put DateTime block after Termination block
   - Fix first message fail check

2022-07-15 zzz
 * SSU2:
   - MTU fixes
   - Send retry with termination on clock skew

2022-07-13 dr|z3d
 * Router: Add short temporary ban for routers when throttled for
   excessive participating tunnel requests

2022-07-12 zzz
 * SSU2: Fail session if first outbound message fails

2022-07-10 zzz
 * SSU2: Fix NACK handling

2022-07-09 zzz
 * Console: Only display news if a new entry is found
 * SSU2: Support other reason codes in destroy message

2022-07-08 zzz
 * SSU: Initialize MTUs
 * SSU2: Persist SSU2 tokens
 * Transports: Don't lookup RI in wasUnreachable()

2022-07-05 zzz
 * SSU2: Fix peer test throttling

2022-07-04 zzz
 * Console: Add cancel button to netdb search form
 * NetDb: Lookup handling cleanups

2022-07-02 dr|z3d
 * Router:
   - Increase timeout for iterative search job and increase concurrency
     for non-slow routers
   - Increase max floodfills we attempt to store keys with and increase
   parallelization

2022-07-02 zzz
 * SSU: Remove copy of peers in idle timeout checker

2022-06-25 zzz
 * SSU: MTU fixes for IPv6 and SSU2



----------------

EARLIER HISTORY IS AVAILABLE IN THE SOURCE PACKAGE